/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package others;
import java.net.URL;
import java.io.IOException;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.image.ImageObserver;
import javax.swing.JFrame;
import javax.swing.JComponent;
/**
 *
 * @author Ali
 */
public final class GoogleMap extends JComponent implements ImageObserver {
   static final String http = "http://maps.google.com/maps/api/staticmap?";
   Image map;
   public GoogleMap(String params) throws IOException { fetch(params); }
   public void fetch(String params) throws IOException { // get another map
      if (map != null) map.flush();
      java.net.URLConnection con = new URL(http + params).openConnection();
      java.io.InputStream is = con.getInputStream();
      byte bytes[] = new byte[con.getContentLength()];
      for (int x =  is.read(bytes, 0, bytes.length);
               x <  bytes.length;
               x += is.read(bytes, x, bytes.length - x));
      is.close();
      java.awt.Toolkit tk = getToolkit();
      map = tk.createImage(bytes);
      tk.prepareImage(map, -1, -1, this);
   }
   public boolean imageUpdate(Image i, int f, int x, int y, int w, int h) {
      if ((f & WIDTH + HEIGHT) == WIDTH + HEIGHT) setSize(w, h);
      if (isShowing() && (f & (ALLBITS | FRAMEBITS)) != 0) repaint();
      return isShowing();
   }
   public java.awt.Dimension getPreferredSize() { return getSize(); }
   public void paint(Graphics g) { g.drawImage(map, 0, 0, this); }

}