/*
 * Yaver10App.java
 */

package yaver10;

import com.lti.civil.CaptureException;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class Yaver10App extends SingleFrameApplication {

    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
        try {
            
            
            show(new Yaver10View(this));
            this.getMainView().getFrame().setPreferredSize(new Dimension(779,700));
            this.getMainView().getFrame().setMaximumSize(new Dimension(779,700));
            this.getMainView().getFrame().setMinimumSize(new Dimension(779,700));
            
       
            this.getMainFrame().setMaximumSize(new Dimension(779,700));
            this.getMainFrame().setMinimumSize(new Dimension(779,700));
            this.getMainFrame().setPreferredSize(new Dimension(779,700));
            
            this.getMainFrame().setResizable(false);
            
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            this.getMainFrame().setLocation(screenSize.width-779, 10);
  //          System.out.println(screenSize.width);
            

        } catch (IOException ex) {
            Logger.getLogger(Yaver10App.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            Logger.getLogger(Yaver10App.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(Yaver10App.class.getName()).log(Level.SEVERE, null, ex);
        } catch (CaptureException ex) {
            Logger.getLogger(Yaver10App.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of Yaver10App
     */
    public static Yaver10App getApplication() {
        return Application.getInstance(Yaver10App.class);
    }

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
        launch(Yaver10App.class, args);
    }
}
